//
//  DistributorSettingAlertView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/11/4.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol DistributorSettingAlertViewDelegate {
    func DistributorSettingAlertViewSubmitAction(tag:Int,operation_type:Int,dbt_price:String,commission_type:Int,commission_per:String,commission_val:String,view:DistributorSettingAlertView)
}
class DistributorSettingAlertView: UIView {
    
    @IBOutlet weak var percent_price_lbl: UILabel!
    var temp_commission_per = ""
    var temp_commission_val = ""
    var temp_commission_price = ""
    var temp_commission_type = 1
    var is_all_select_mode = false
    var data:supGoodsListResDataModel?{
        didSet{
            if data?.is_dbt == 0{
                canYuBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
                nonCanYuBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
                contentVheight.constant = 150
                canYuBtn.isSelected = false
                nonCanYuBtn.isSelected = true
                cover_view.isHidden = true
            }else{
                canYuBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
                nonCanYuBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
                canYuBtn.isSelected = true
                nonCanYuBtn.isSelected = false
                contentVheight.constant = 300
                if is_all_select_mode {
                    cover_view.isHidden = false
                }else{
                    moneyTx.text = data?.dbt_price
                }
                temp_commission_type = (data?.commission_type)!
                if data?.commission_type == 1 {
                    payBiBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
                    payJueBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
                    payBiBtn.isSelected = true
                    payJueBtn.isSelected = false
                    payNumTypelbl.text = "%"
                    payTF.text = StringByInt(number: (data?.commission_per)!)
                    temp_commission_per = StringByInt(number: (data?.commission_per)!)
                    if data?.dbt_price != nil {
                        temp_commission_price = (data?.dbt_price)!
                        let price = Float(temp_commission_price)
                        let percent = Float(temp_commission_per)
                        let c_price = price! * 0.01 * percent!
                        percent_price_lbl.text = "(" + String(format: "%.2f", c_price) + "元)"
                        percent_price_lbl.isHidden = false
                    }
                }else{
                    payBiBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
                    payJueBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
                    payBiBtn.isSelected = false
                    payJueBtn.isSelected = true
                    payNumTypelbl.text = "元"
                    payTF.text = data?.commission_val
                    temp_commission_val = (data?.commission_val)!
                    percent_price_lbl.isHidden = true
                }
                
            }
        }
    }
    var delegate:DistributorSettingAlertViewDelegate?
    @IBOutlet weak var canYuBtn: UIButton!
    
    @IBAction func canyuAction(_ sender: UIButton) {
        //参与
        canYuBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
        nonCanYuBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
        canYuBtn.isSelected = true
        nonCanYuBtn.isSelected = false
        percent_price_lbl.isHidden = false
        contentVheight.constant = 300
        if is_all_select_mode {
            cover_view.isHidden = false
        }
        
        
    }
    @IBOutlet weak var nonCanYuBtn: UIButton!
    
    @IBAction func nonCanyuAction(_ sender: UIButton) {
        //不参与
        canYuBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
        nonCanYuBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
        contentVheight.constant = 150
        canYuBtn.isSelected = false
        percent_price_lbl.isHidden = true
        nonCanYuBtn.isSelected = true
        cover_view.isHidden = true
    }
    
    @IBOutlet weak var moneyTx: UITextField!
    
    @IBOutlet weak var contentVheight: NSLayoutConstraint!
    
    @IBOutlet weak var payBiBtn: UIButton!
    
    @IBOutlet weak var payJueBtn: UIButton!
    
    @IBAction func payAction(_ sender: UIButton) {
        //提成比例
        payBiBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
        payJueBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
        payBiBtn.isSelected = true
        payJueBtn.isSelected = false
        payNumTypelbl.text = "%"
        payTF.placeholder = "请输入比例"
        temp_commission_type = 1
        payTF.text = temp_commission_per
        percent_price_lbl.isHidden = false
        
    }
    @IBAction func payJueAction(_ sender: UIButton) {
        //绝对值
        payBiBtn .setImage(UIImage.init(named: "daixuan"), for: .normal)
        payJueBtn .setImage(UIImage.init(named: "yuxuan"), for: .normal)
        payBiBtn.isSelected = false
        payJueBtn.isSelected = true
        payNumTypelbl.text = "元"
        payTF.placeholder = "请输入数值"
        temp_commission_type = 2
        payTF.text = temp_commission_val
        percent_price_lbl.isHidden = true
    }
    
    @objc func textChange(textField:UITextField){
        if textField == moneyTx {
            if temp_commission_per != "" {
                let price = Float(textField.text!)!
                let percent = Float(temp_commission_per)!
                let c_price = price * 0.01 * percent
                percent_price_lbl.text = "(" + String(format: "%.2f", c_price) + "元)"
            }
            temp_commission_price = moneyTx.text!
        }else{
            if temp_commission_price != "" {
                let fx_price = Float(temp_commission_price)
                let input_value = Float(textField.text!)
                if temp_commission_type == 1 {//比例
                    if textField.text == "" {
                        return
                    }
                    if input_value! > 100 {
                        HUD.flash(.label("提成不大于100%~"), delay: 1.2)
                        textField.text! = ""
                        return
                    }else{
                        let c_price = input_value! * 0.01 * fx_price!
                        percent_price_lbl.text = "(" + String(format: "%.2f", c_price) + "元)"
                        temp_commission_per = textField.text!
                    }
                }else{
                    if textField.text == "" {
                        return
                    }
                    if input_value! > fx_price! {
                        HUD.flash(.label("提成大于分销价~"), delay: 1.2)
                        textField.text! = ""
                        return
                    }
                    temp_commission_val = textField.text!
                }
            }else{
                HUD.flash(.label("请输入分销价"), delay: 1.2)
                textField.text = ""
            }
        }
    }
    
    @IBOutlet weak var payTF: UITextField!
    @IBOutlet weak var payNumTypelbl: UILabel!
    
    @IBAction func cancelAction(_ sender: Any) {
        //取消
        self.removeFromSuperview()
    }
    
    
    
    
    @IBAction func sureAction(_ sender: UIButton) {
        if canYuBtn.isSelected && payBiBtn.isUserInteractionEnabled {
            if  (payTF.text?.count == 0 || moneyTx.text?.count == 0){
                HUD.flash(.label("请输入数据~"), delay: 1.2)
                return
            }
        }
        if canYuBtn.isSelected && payBiBtn.isUserInteractionEnabled == false{
            if  (payTF.text?.count == 0){
                HUD.flash(.label("请输入数据~"), delay: 1.2)
                return
            }
        }
        
        //确定
        var operation_type = 1
        if nonCanYuBtn.isSelected {
            operation_type = 2
        }
        
        var commission_type = 1
        var commission_per = ""
        var commission_val = ""
        let fx_price = moneyTx.text
        if payJueBtn.isSelected  {
            commission_type = 2
            commission_val = payTF.text!
            
            if Float(commission_val)! > Float(fx_price!)! {
                HUD.flash(.label("提成大于分销价~"), delay: 1.2)
                payTF.text! = ""
                return
            }
        }else{
            commission_per = payTF.text!
            if Float(commission_per)! > 100 {
                HUD.flash(.label("提成不大于100%~"), delay: 1.2)
                payTF.text! = ""
                return
            }
        }
        
        delegate?.DistributorSettingAlertViewSubmitAction(tag: self.tag, operation_type: operation_type, dbt_price: moneyTx.text!, commission_type: commission_type, commission_per: commission_per, commission_val: commission_val,view:self)
    }
    
    @IBOutlet weak var cover_view: UIView!
    var contentView:UIView!
    override func layoutSubviews() {
        super.layoutSubviews()
        if is_all_select_mode {
            cover_view.isHidden = false
            payJueBtn.setImage(UIImage.init(named: "daixuan"), for: .normal)
            payBiBtn.setImage(UIImage.init(named: "yuxuan"), for: .normal)
            payBiBtn.isUserInteractionEnabled = false
            payJueBtn.isUserInteractionEnabled = false
            payNumTypelbl.text = "%"
            payTF.placeholder = "请输入比例"
        }
    }
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        payTF.addTarget(self, action: #selector(textChange(textField:)), for: .editingChanged)
        moneyTx.addTarget(self, action: #selector(textChange(textField:)), for: .editingChanged)
    }
    
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        payTF.addTarget(self, action: #selector(textChange(textField:)), for: .editingChanged)
        moneyTx.addTarget(self, action: #selector(textChange(textField:)), for: .editingChanged)
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
