//
//  GLAlertTbAddView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/11/4.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class GLAlertTbAddView: UIView,UITableViewDelegate,UITableViewDataSource,GLAlertTbAddViewCellDelegate,TitleAndSelectCellDelegate{
    
    var is_gys = false {
        didSet{
            if is_gys{
                title_lbl.text = "新增供应商"
            }
        }
    }
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    func GLAlertTbAddViewCellBtnAction(target: String,tag:Int) {
        if target == "新增"{
            datas.insert("", at: 0)
        }else{
            datas.remove(at: tag)
        }
        if datas.count == 1 {
            center_view_height.constant = 165
        }else{
            center_view_height.constant = 230
        }
        list_tableview.reloadData()
    }
    
    
    
    
    var centers:Array<getAllShopDataModel> = []{
        didSet{
            print(centers.count,gys_centers.count)
            bottom_tableview.reloadData()
        }
    }
    var gys_centers:Array<getSupShopDataModel> = []{
        didSet{
            print(centers.count,gys_centers.count)
            bottom_tableview.reloadData()
        }
    }
    var datas:Array<String> = [""]
    @IBOutlet weak var center_view_height: NSLayoutConstraint!
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == list_tableview {
            return datas.count
        }else{
            if title_lbl.text == "新增供应商" {
                return gys_centers.count
            }
            return centers.count
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView == list_tableview {
            let cell = tableView.dequeueReusableCell(withIdentifier: "GLAlertTbAddViewCell")! as! GLAlertTbAddViewCell
            cell.delegate = self
            cell.actionBtn.setTitle("新增", for: .normal)
            cell.actionBtn.setTitleColor(UIColor(named: "按钮背景颜色"), for: .normal)
            cell.tag = indexPath.row
            cell.count_lbl.text = "店铺" + StringByInt(number: datas.count - indexPath.row)
            if datas.count > 1 {
                if indexPath.row != 0 {
                    cell.actionBtn.setTitle("删除", for: .normal)
                    cell.actionBtn.setTitleColor(UIColor(named: "#F57575"), for: .normal)
                }
            }
            let str = datas[indexPath.row] as! String
            if str.count > 0 {
                cell.title_lbl.text = str
            }else{
                cell.title_lbl.text = "请选择店铺"
            }
            return cell
        }else{
            
            if title_lbl.text == "新增供应商" {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell")! as! TitleAndSelectCell
                cell.is_center_select = true
                cell.delegate = self
                let model = gys_centers[indexPath.row]
                cell.titleLbl.text = model.shop_name
                let str = datas[idx] as! String
                if str.count > 0{
                    if cell.titleLbl.text == str {
                        cell.selectBtn.isSelected = true
                    }else{
                        cell.selectBtn.isSelected = false
                    }
                }
                
                return cell
            }
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell")! as! TitleAndSelectCell
            cell.is_center_select = true
            cell.delegate = self
            let model = centers[indexPath.row]
            cell.titleLbl.text = model.shop_name
            let str = datas[idx] as! String
            cell.selectBtn.isSelected = false
            if str.count > 0{
                if cell.titleLbl.text == str {
                    cell.selectBtn.isSelected = true
                }
            }
            return cell
        }
        
        
    }
    
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        if scrollView != bottom_tableview {
            bottom_tableview.isHidden = true
        }
    }
    
    var idx:Int = 0
    func GLAlertTbAddViewCellSelectAction(tag:Int) {
        bottom_tableview.isHidden = false
        idx = tag
        bottom_tableview.reloadData()
    }
    //MARK: - 选择店铺
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if tableView == bottom_tableview {
            tableView.visibleCells.forEach { (item) in
                let cell = item as! TitleAndSelectCell
                cell.selectBtn.isSelected = false
            }
            if title_lbl.text == "新增供应商" {
                let model = gys_centers[indexPath.row]
                datas.insert(model.shop_name!, at: idx)
            }else{
                let model = centers[indexPath.row]
                datas.insert(model.shop_name!, at: idx)
            }
            datas.remove(at: idx+1)
            list_tableview.reloadData()
            bottom_tableview.isHidden = true
        }
    }
    
    var contentView:UIView!
    
    @IBAction func closeCover(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    @IBAction func btnAction(_ sender: UIButton) {
        if sender.tag == 0 {
            var shop_id = ""
            var d:Array<String> = []
            let results = datas.enumerated().filter { (index,value) -> Bool in
                return datas.firstIndex(of: value) == index
            }.map {
                $0.element
            }
            results.forEach { (str) in
                if str != "" {
                    d.append(str)
                }
            }
            if title_lbl.text == "新增供应商" {
                for i in 0 ..< d.count{
                    let str = d[i]
                    gys_centers.forEach { (item) in
                        if item.shop_name == str {
                            if i < d.count-1 {
                                shop_id += StringByInt(number: item.shop_id!) + ","
                            }else{
                                shop_id += StringByInt(number: item.shop_id!)
                            }
                        }
                    }
                }
                if shop_id.count == 0 {
                    HUD.flash(.label("商店不能为空"), delay: 1.2)
                    return
                }
                HUD.flash(.progress)
                dbtAddContract(["user_token":UserToken as Any,"shop_id":shop_id as Any]) { (data) in
                    self.removeFromSuperview()
                    HUD.hide()
                    NotificationCenter.default.post(name: NSNotification.Name(rawValue: "haveAdd"), object: "fxsAdd")
                } failture: { (err) in
                }
                return
            }
            for i in 0 ..< d.count{
                let str = d[i]
                
                centers.forEach { (item) in
                    if item.shop_name == str {
                        if i < d.count-1 {
                            shop_id += StringByInt(number: item.shop_id!) + ","
                        }else{
                            shop_id += StringByInt(number: item.shop_id!)
                        }
                    }
                }
            }
            if shop_id.count == 0 {
                HUD.flash(.label("商店不能为空"), delay: 1.2)
                return
            }
            HUD.flash(.progress)
            supAddContract(["user_token":UserToken as Any,"shop_id":shop_id as Any]) { (data) in
                HUD.hide()
                self.removeFromSuperview()
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "haveAdd"), object: "fxsAdd")
            } failture: { (err) in
            }
        }else{
            self.removeFromSuperview()
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView == list_tableview {
            return 65
        }else{
            return 44
        }
    }
    
    @IBOutlet weak var title_lbl: UILabel!
    @IBOutlet weak var bottom_tableview: UITableView!
    @IBOutlet weak var list_tableview: UITableView!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        list_tableview.separatorStyle = .none
        list_tableview.register(UINib(nibName: "GLAlertTbAddViewCell", bundle: nil), forCellReuseIdentifier: "GLAlertTbAddViewCell")
        
        bottom_tableview.separatorStyle = .none
        bottom_tableview.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
//        loadData()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        print("2")
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        list_tableview.separatorStyle = .none
        list_tableview.register(UINib(nibName: "GLAlertTbAddViewCell", bundle: nil), forCellReuseIdentifier: "GLAlertTbAddViewCell")
        
        bottom_tableview.separatorStyle = .none
        bottom_tableview.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
//        loadData()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}

