//
//  GLTimeSelectView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import SwiftDate
import LGButton

protocol GLTimeSelectViewDelegate {
    func GLTimeSelectViewSelectFinish(date:String)
    func GLTimeSelectViewClose()
}

class GLTimeSelectView: UIView, UIPickerViewDelegate, UIPickerViewDataSource {
    var isOnlyDay = false
    @IBOutlet weak var btns_bg_view_height: NSLayoutConstraint!
    @IBOutlet weak var picker_height: NSLayoutConstraint!
    @IBOutlet weak var btns_bg_view: UIView!
    @IBOutlet weak var year_btn: UIButton!
    @IBOutlet weak var day_btn: UIButton!
    @IBOutlet weak var month_btn: UIButton!
    
    var delegate:GLTimeSelectViewDelegate?
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return nums
    }
    var nums = 3
    
    @IBAction func date_type_select(_ sender: UIButton) {
        sender.backgroundColor = UIColor(named: "按钮渐变色下,字体颜色")
        switch sender.tag {
        case 0:
            day_btn.isSelected = true
            month_btn.isSelected = false
            year_btn.isSelected = false
            month_btn.backgroundColor = UIColor.clear
            year_btn.backgroundColor = UIColor.clear
            nums = 3
            break
        case 1:
            month_btn.isSelected = true
            day_btn.isSelected = false
            year_btn.isSelected = false
            day_btn.backgroundColor = UIColor.clear
            year_btn.backgroundColor = UIColor.clear
            nums = 2
            break
        default:
            year_btn.isSelected = true
            month_btn.isSelected = false
            day_btn.isSelected = false
            month_btn.backgroundColor = UIColor.clear
            day_btn.backgroundColor = UIColor.clear
            nums = 1
            break
        }
        time_picker.reloadAllComponents()
        switch nums {
        case 1:
            time_picker.selectRow(yearSelect, inComponent: 0, animated: false)
            break
        case 2:
            time_picker.selectRow(yearSelect, inComponent: 0, animated: false)
            time_picker.selectRow(monthSelect, inComponent: 1, animated: false)
            break
        default:
            time_picker.selectRow(yearSelect, inComponent: 0, animated: false)
            time_picker.selectRow(monthSelect, inComponent: 1, animated: false)
            time_picker.selectRow(daySelect, inComponent: 2, animated: false)
            break
        }
        
    }
    
    
    
    @IBAction func submit_action(_ sender: LGButton) {
        
        switch nums {
        case 1:
            dateStr = years[yearSelect]
            break
        case 2:
            dateStr = years[yearSelect] + "-" + months[monthSelect]
            break
        default:
            dateStr = years[yearSelect] + "-" + months[monthSelect] + "-" +  days[daySelect]
            break
        }
        delegate?.GLTimeSelectViewSelectFinish(date:dateStr)
        self.removeFromSuperview()
    }
    @IBAction func close_action(_ sender: Any) {
        delegate?.GLTimeSelectViewClose()
        self.removeFromSuperview()
    }
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if component == 0 {
            return years.count
        }else if component == 1 {
            return months.count
        }
        return days.count
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
    
        if component == 0 {
            return years[row]
        }else if component == 1 {
            return months[row]+"月"
        }
        return days[row]+"日"
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        let arr = getDate()
        switch component {
        case 0:
            yearSelect = row
            if yearSelect == years.count-1{
                if arr[1] < 12 {
                    months.removeAll()
                    var m = 1
                    while m <= arr[1] {
                        months.append(StringByInt(number: m))
                        m += 1
                    }
                }
                if arr[1] == 12 {
                    if arr.last! < 31{
                        days.removeAll()
                        var d = 1
                        while d <= arr.last! {
                            days.append(StringByInt(number: d))
                            d += 1
                        }
                        if nums > 2 {
                            pickerView.reloadComponent(2)
                        }
                    }
                }
            }else{
                if months.count < 12 {
                    months.removeAll()
                    var m = 1
                    while m <= 12 {
                        months.append(StringByInt(number: m))
                        m += 1
                    }
                }
                if days.count < 31 {
                    days.removeAll()
                    var d = 1
                    while d <= 31 {
                        days.append(StringByInt(number: d))
                        d += 1
                    }
                    if nums > 2 {
                        pickerView.reloadComponent(2)
                    }
                }
            }
            if nums > 1 {
                pickerView.reloadComponent(1)
            }
            break
        case 1:
            monthSelect = row
            if yearSelect == years.count-1 && monthSelect == months.count-1{
                if days.count != arr.last! {
                    days.removeAll()
                    var d = 1
                    while d <= arr.last! {
                        days.append(StringByInt(number: d))
                        d += 1
                    }
                }
            }else{
                let dayNum = "\(years[yearSelect])-\(months[monthSelect])-1".toDate()?.dateAtEndOf(.month).day
                var d = 1
                days.removeAll()
                while d <= dayNum! {
                    days.append(StringByInt(number: d))
                    d += 1
                }
            }
            if nums > 2 {
                pickerView.reloadComponent(2)
            }
            break
        default:
            daySelect = row
            break
        }
    }
    
    var yearSelect = -1
    var monthSelect = -1
    var daySelect = -1
    
    func getYearNum(year:NSString)->Int{
        var strTime = 2017
        var i = 0
        while strTime <= year.integerValue {
            strTime += 1
            if strTime != year.integerValue {
                i += 1
            }
        }
        return i
    }
    
    var dateStr = ""{
        didSet{
            if dateStr.count == 4 {
                yearSelect = getYearNum(year: dateStr as NSString)
                date_type_select(year_btn)
            }else if dateStr.count > 4 && dateStr.count <= 7{
                let arr = dateStr.components(separatedBy: "-")
                yearSelect = getYearNum(year: arr.first! as NSString)
                monthSelect = (arr[1] as NSString).integerValue - 1
                date_type_select(month_btn)
            }else{
                let arr = dateStr.components(separatedBy: "-")
                yearSelect = getYearNum(year: arr.first! as NSString)
                monthSelect = (arr[1] as NSString).integerValue - 1
                daySelect = (arr[2] as NSString).integerValue - 1
                date_type_select(day_btn)
            }
        }
    }
    
    
    var years:Array<String> = []
    var months:Array<String> = []
    var days:Array<String> = []
    @IBOutlet weak var time_picker: UIPickerView!
    var contentView:UIView!
    
    func getDate()->Array<Int>{
        let date = Date()
        let timeFormatter = DateFormatter()
        //日期显示格式，可按自己需求显示
        timeFormatter.dateFormat = "yyyy-MM-dd"
        let strNowTime = timeFormatter.string(from: date) as String
        let dateArr = strNowTime.components(separatedBy: "-")
        let year = Int(dateArr.first!)!
        let month = Int(dateArr[1])!
        let day = Int(dateArr[2])!
        return [year,month,day]
    }
    
    func setUI(){
        time_picker.delegate = self
        time_picker.dataSource = self
//        time_picker.showsSelectionIndicator = true
        
        let arr = getDate()
        var strTime = 2017
        while strTime <= arr.first! {
            years.append(StringByInt(number: strTime) )
            strTime += 1
        }
        
        if yearSelect == -1 {
            var m = 1
            while m <= arr[1] {
                months.append(StringByInt(number: m))
                m += 1
            }
        }else{
            var m = 1
            while m <= 12 {
                months.append(StringByInt(number: m))
                m += 1
            }
        }
        
        if yearSelect == -1 && monthSelect == -1 {
            var d = 1
            while d <= arr.last! {
                days.append(StringByInt(number: d))
                d += 1
            }
        }else{
            let dayNum = "\(years[years.count-1])-\(arr[1])-1".toDate()?.dateAtEndOf(.month).day
            var d = 1
            while d <= dayNum! {
                days.append(StringByInt(number: d))
                d += 1
            }
        }
        
        if yearSelect == -1 {
            yearSelect = years.count-1
        }
        if monthSelect == -1 {
            monthSelect = months.count - 1
        }
        if daySelect == -1 {
            daySelect = days.count - 1
        }
        
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        if isOnlyDay {
            btns_bg_view.isHidden = true
            btns_bg_view_height.constant = 0
            picker_height.constant = 306
        }
        if dateStr.count == 4 {
            time_picker.selectRow(yearSelect, inComponent: 0, animated: false)
        }else if dateStr.count > 4 && dateStr.count <= 7 {
            time_picker.selectRow(monthSelect, inComponent: 1, animated: false)
        }else{
            time_picker.selectRow(daySelect, inComponent: 2, animated: false)
        }
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
    
}
